program ultrasonicSensor1;
uses STArduino;

const 	trigPin = 12;
		echoPin = 13;

{Theo 'Parallax's datasheet for the PING', co 73.746 microseconds tren moi inch
	(nghia la moi giay am thanh di chuyen mot doan 1130 feet). Voi khoang cach tu
	ultra sonic den vat can va nguoc lai, ta chia 2 de duoc khoang cach den vat can}
function microsecondsToInches(microseconds: longint): real;
begin
	microsecondsToInches := microseconds/74/2;	
end;

{Vat toc am thanh la 340m/s hoac la 29 microseconds/cm.
	Voi khoang cach tu ultra sonic den vat can va nguoc lai, 
	ta chia 2 de duoc khoang cach den vat can}
function microsecondsToCentimeters(microseconds: longint): real;
begin
	microsecondsToCentimeters := microseconds/29/2;	
end;
		
procedure setup;
begin
	serialBegin(9600);			{khoi tao cong giao tiep serial}
	pinMode(trigPin,OUTPUT);	{chan trig se phat tin hieu}
	pinMode(echoPin,INPUT);		{chan echo se nhan tin hieu}
end;

procedure loop;
var inches, cm: real;
	duration: longint;
begin
	digitalWrite(trigPin,LOW);	{tat chan trig}
	delayMicroseconds(2);
	digitalWrite(trigPin,HIGH);	{phat xung tu chan trig}
	delayMicroseconds(5);		{xung co do dai 5 microSeconds}
	digitalWrite(trigPin,LOW);	{tat chan trig}

	{Tinh toan thoi gian. Do do rong xung HIGH o chan echo}
	duration := pulseIn(echoPin,HIGH);  
	
	{Tinh khoang cach den vat}
	inches := microsecondsToInches(duration);
	cm := microsecondsToCentimeters(duration);
	serialPrintString('Khoang cach cm): '); serialPrintlnReal(cm);
	serialPrintString('Khoang cach (inches): '); serialPrintlnReal(inches);
    delay(500);
end;

begin
	setup;
	loop;	
end.
